from dataclasses import dataclass
from typing import Callable

import pygame

from views.components.ui.ReactTextField import ReactTextField, ReactPropsTextField
from views.events.EventMouse import EventMouse
from views.react.ReactComponent import ReactProps, ReactState, ReactComponent


@dataclass
class ReactPropsButton(ReactProps):
    title: str = ''
    onPress: Callable = None


@dataclass
class ReactStateButton(ReactState):
    isMouseOver: bool = False


class ReactButton(ReactComponent):
    def __init__(self, props):
        super().__init__(props)


        self.state = ReactStateButton()

    def onPress(self, event: EventMouse):
        # TODO
        pass

    def onMouseMove(self, event: EventMouse):
        # TODO
        pass

    def render(self):
        return [
            ReactTextField(
                ReactPropsTextField(
                    x=self.props.x + 5,
                    y=self.props.y + 5,
                    width=self.props.width - 5,
                    height=self.props.height - 5,
                    text=self.props.title
                )
            )
        ]

    def draw(self, screen):
        #TODO
        super().draw(screen)